@echo off
cls
setlocal enabledelayedexpansion

REM set variables
set should-clean=0
set should-disable-update=0
set should-installer=0
set should-zip=0
set should-source=0
set NSIS="%ProgramFiles(x86)%\NSIS\makensis.exe"
set /p commitver=< version.txt
set commitbuildver=%commitver%

REM parse flags
:parse
if "%~1%"=="" GOTO endparse
if "%~1%"=="/c" set should-clean=1
if "%~1%"=="/n" set should-disable-update=1
if "%~1%"=="/i" set should-installer=1
if "%~1%"=="/z" set should-zip=1
if "%~1%"=="/s" set should-source=1
shift
goto parse
:endparse

REM cleanup
echo Doing some cleanup...
if %should-clean%==1 (
    rmdir /s /q build
)
rmdir /s /q dist
mkdir dist\commit


REM build
echo Executing the py2exe build...
python .\setup.py py2exe


REM add Pandoc to bundle
echo Getting Pandoc and installing to bundle...
echo import pypandoc > build\pandoc.py
echo import os >> build\pandoc.py
echo dl_path = os.path.abspath(".") >> build\pandoc.py
echo target_path = os.path.abspath("../dist/commit") >> build\pandoc.py
echo pypandoc.pandoc_download.download_pandoc(download_folder=dl_path, targetfolder=target_path) >> build\pandoc.py
cd build
python pandoc.py
cd ..
move dist\commit\COPYRIGHT.txt dist\commit\pandoc-copyright.txt

REM set noupdate status
if %should-disable-update%==1 (
    echo. > .\dist\commit\noupdate
    set commitbuildver=%commitver%_noupdate
)

REM if installer is requested
if %should-installer%==1 (
    if exist %NSIS% (
        %NSIS% commit-installer.nsi
    ) else (
        echo NSIS compiler not found at expected location: %NSIS%`
    )
)

REM if ZIP is requested
if %should-zip%==1 (
    powershell Compress-Archive -Path dist\commit -DestinationPath .\dist\commit_windows_%commitver%.zip
)

REM if source package is requested
set source-dir=..\commit-%commitver%-source
set dest-dir=.\build\commit-%commitver%-source
set exclusions=..\commit-exclusions.txt
if %should-source%==1 (
    rmdir /s /q %source-dir%
    rmdir /s /q %dest-dir%
    echo build\ > %exclusions%
    echo dist\ >> %exclusions%
    echo venv\ >> %exclusions%
    echo .idea\ >> %exclusions%
    echo __pycache__ >> %exclusions%
    echo .git\ >> %exclusions%
    mkdir %source-dir%
    xcopy /s /exclude:%exclusions% * %source-dir%
    del /q %exclusions%
    move /y %source-dir% %dest-dir%
    powershell Compress-Archive -Path %dest-dir% -DestinationPath .\dist\commit_%commitver%_source.zip
)

echo Our work here is done.

