# This is a configuration file for the Nullsoft Scriptable Install System
# https://nsis.sourceforge.io/

# installer name
Name "Commit"

# installer file name (%commitver% set in build-windows.cmd from version.txt)
Outfile "dist\commit_windows_$%commitbuildver%.exe"

# Default install directory
InstallDir $PROGRAMFILES\Commit

# Installer text
DirText "This will install Commit on your computer. Choose the installation directory."

# vars
!define REGNAME "IntersanityCommit"
!define EXENAME "commit.exe"
!define REGFILEEXT ".ctxt"
!define REGPATH_UNINSTSUBKEY "Software\Microsoft\Windows\CurrentVersion\Uninstall\${REGNAME}"
!define REGPATH_FILETYPEKEY "Software\Classes\${REGNAME}"
!define REGPATH_ASSOCEXE "Software\Classes\Applications\${EXENAME}"

# Install section
Section "Install"
    SetOutPath $INSTDIR

    # clear out any old installations
    RMDir /r $INSTDIR

    # get all files in dist
    File /r dist\commit\*

    # make an uninstaller
    WriteUninstaller $INSTDIR\Uninstall.exe
    WriteRegStr HKLM "${REGPATH_UNINSTSUBKEY}" "DisplayName" "Commit: the Advanced Modern Typewriter"
    WriteRegStr HKLM "${REGPATH_UNINSTSUBKEY}" "Publisher" "Intersanity Enterprises"
    WriteRegStr HKLM "${REGPATH_UNINSTSUBKEY}" "UninstallString" "$\"$INSTDIR\Uninstall.exe$\""
    WriteRegStr HKLM "${REGPATH_UNINSTSUBKEY}" "QuietUninstallString" "$\"$INSTDIR\Uninstall.exe$\" /S"
    WriteRegStr HKLM "${REGPATH_UNINSTSUBKEY}" "DisplayIcon" "$\"$INSTDIR\${EXENAME}$\",0"
    WriteRegStr HKLM "${REGPATH_UNINSTSUBKEY}" "DisplayVersion" "$%commitver%"
    WriteRegDWORD HKLM "${REGPATH_UNINSTSUBKEY}" "NoModify" "1"
    WriteRegDWORD HKLM "${REGPATH_UNINSTSUBKEY}" "NoRepair" "1"

    # start menu shortcut
    CreateShortCut "$SMPROGRAMS\Commit.lnk" "$INSTDIR\commit.exe"

    # file type associations
    WriteRegStr HKLM "${REGPATH_FILETYPEKEY}\DefaultIcon" "" "$\"$INSTDIR\commit.exe$\",1"
    WriteRegStr HKLM "${REGPATH_FILETYPEKEY}\shell\open\command" "" "$\"$INSTDIR\commit.exe$\" $\"%1$\""
    WriteRegStr HKLM "Software\Classes\${REGFILEEXT}" "" "${REGNAME}"
    WriteRegStr HKLM "${REGPATH_ASSOCEXE}\shell\open\command" "" "$\"$INSTDIR\commit.exe$\" $\"%1$\""
    WriteRegStr HKLM "${REGPATH_ASSOCEXE}" "FriendlyAppName" "Commit"
    WriteRegStr HKLM "${REGPATH_ASSOCEXE}" "ApplicationCompany" "Intersanity Enterprises"
SectionEnd

# Uninstall section
Section "Uninstall"
    # remove app dir
    Delete $INSTDIR\Uninstall.exe
    RMDir /r $INSTDIR

    # remove uninstaller reference
    DeleteRegKey HKLM "${REGPATH_UNINSTSUBKEY}"

    # remove file associations
    DeleteRegKey HKLM "${REGPATH_FILETYPEKEY}"
    DeleteRegKey HKLM "Software\Classes\${REGFILEEXT}"
    DeleteRegKey HKLM "${REGPATH_ASSOCEXE}"

    # remove start menu shortcut
    Delete "$SMPROGRAMS\Commit.lnk"
SectionEnd